use yew::prelude::*;
use yew::services::resize::*;

pub struct App {
    _link: ComponentLink<Self>,
    _resize: ResizeTask,
}

pub enum Msg {
    Resize(WindowDimensions),
}

impl Component for App {
    type Message = Msg;
    type Properties = ();

    fn create(_props: Self::Properties, link: ComponentLink<Self>) -> Self {
        let resize_callback = link.callback(Self::Message::Resize);
        Self {
            _link: link,
            _resize: ResizeService::new().register(resize_callback),
        }
    }

    fn update(&mut self, msg: Self::Message) -> ShouldRender {
        match msg {
            Self::Message::Resize(dim) => {
                yew::services::ConsoleService::new().log(&format!("{:#?}", dim));
                true
            }
        }
    }

    fn view(&self) -> Html {
        html! {
            <h1>{ "This is an application" }</h1>
        }
    }
}
